<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js" integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <!-- Nhúng thư viện data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <h1 style="justify-content: center; display: flex;">Danh sách đăng ký</h1>
    <table id="user-table" class="table table-striped table-dark table-bordered table-hover">
        <thead>
        <tr>
            <th>Mã người dùng</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
        </tr>
    </thead>
    <tbody>

    </tbody>
    </table>
</body>
<script>
        "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gDATA_COLUMNS=[
        "id",
        "firstname",
        "lastname",
        "country",
        "subject",
        "customerType",
        "registerStatus",
        "action",
    ]
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading()
        $("#user-table").on("click",".btn-detail",function(){
            onBtnChiTietClick(this)
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý khi load trang
    function onPageLoading(){
        $.ajax({
            url:gBASE_URL,
            type:"GET",
            dataType:"json",
            success:function(responseObject){
                console.log((responseObject))
               var vTable= $("#user-table").DataTable({
            data:responseObject,
            columns:[
                {"data":gDATA_COLUMNS[0]},
                {"data":gDATA_COLUMNS[1]},
                {"data":gDATA_COLUMNS[2]},
                {"data":gDATA_COLUMNS[3]},
                {"data":gDATA_COLUMNS[4]},
                {"data":gDATA_COLUMNS[5]},
                {"data":gDATA_COLUMNS[6]},
            ],
            columnDefs:[
                {targets : 7,
                defaultContent:`<button class="btn btn-info btn-detail">Chi tiết</button>`}
            ],
        } 
        )
            },
            error: function(error){
                console.assert(error.responseText)
            }
        })
    }
    //Hàm xử lý khi click nút chi tiết
function onBtnChiTietClick(paramElement){
    var vTable = $("#user-table").DataTable()
    var vRowClick=$(paramElement).parent()
    var vDataRow = vTable.row(vRowClick).data()
    console.log(vDataRow)
}
</script>
</html>